Bug 1271300 - Satellite throws an error when product name changes in the CDN
Satellite throws an error when product name changes in the CDN
Status: CLOSED WONTFIX
Product: Red Hat Satellite 6
Classification: Red Hat
Component: Subscription Management (Show other bugs)
6.1.0
Unspecified Unspecified
medium Severity medium (vote)
: Unspecified
: --
Assigned To: satellite6-bugs
Katello QA List
: Triaged
Depends On:
Blocks: GSS_Sat6Beta_Tracker/GSS_Sat6_Tracker
  Show dependency treegraph
 
Reported: 2015-10-13 10:57 EDT by David Davis
Modified: 2017-08-01 16:34 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-01 16:34:25 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description David Davis 2015-10-13 10:57:57 EDT
Description of problem:

Recently the product names for OSP changed in the CDN from "Red Hat OpenStack..." to "Red Hat Enterprise Linux Openstack...". This caused us on RHCI to experience errors when trying to enable new repos after importing a new manifest:

Oct 12 16:12:06 sat61dev pulp: pulp.plugins.pulp_rpm.plugins.distributors.yum.configuration:ERROR: Relative URL [Default_Organization/Library/content/dist/rhel/server/7/7Server/x86_64/openstack-director/7.0/os] for repository [Default_Organization-Red_Hat_OpenStack-Red_Hat_Enterprise_Linux_OpenStack_Platform_7_0_director_for_RHEL_7_RPMs_x86_64_7Server] conflicts with existing relative URL [Default_Organization/Library/content/dist/rhel/server/7/7Server/x86_64/openstack-director/7.0/os] for repository [Default_Organization-Red_Hat_OpenStack-Red_Hat_OpenStack_7_0_for_RHEL_7_Platform_director_RPMs_x86_64_7Server]
Oct 12 16:12:06 sat61dev pulp: pulp.server.managers.repo.cud:ERROR: (9488-74560) Exception adding distributor to repo [Default_Organization-Red_Hat_OpenStack-Red_Hat_Enterprise_Linux_OpenStack_Platform_7_0_director_for_RHEL_7_RPMs_x86_64_7Server]; the repo will be deleted
Oct 12 16:12:06 sat61dev pulp: pulp.server.managers.repo.cud:ERROR: (9488-74560) Traceback (most recent call last):
Oct 12 16:12:06 sat61dev pulp: pulp.server.managers.repo.cud:ERROR: (9488-74560)   File "/usr/lib/python2.7/site-packages/pulp/server/managers/repo/cud.py", line 187, in create_and_configure_repo
Oct 12 16:12:06 sat61dev pulp: pulp.server.managers.repo.cud:ERROR: (9488-74560)     distributor_id)
Oct 12 16:12:06 sat61dev pulp: pulp.server.managers.repo.cud:ERROR: (9488-74560)   File "/usr/lib/python2.7/site-packages/pulp/server/managers/repo/distributor.py", line 184, in add_distributor
Oct 12 16:12:06 sat61dev pulp: pulp.server.managers.repo.cud:ERROR: (9488-74560)     raise PulpDataException(message)
Oct 12 16:12:06 sat61dev pulp: pulp.server.managers.repo.cud:ERROR: (9488-74560) PulpDataException: Relative URL [Default_Organization/Library/content/dist/rhel/server/7/7Server/x86_64/openstack-director/7.0/os] for repository [Default_Organization-Red_Hat_OpenStack-Red_Hat_Enterprise_Linux_OpenStack_Platform_7_0_director_for_RHEL_7_RPMs_x86_64_7Server] conflicts with existing relative URL [Default_Organization/Library/content/dist/rhel/server/7/7Server/x86_64/openstack-director/7.0/os] for repository [Default_Organization-Red_Hat_OpenStack-Red_Hat_OpenStack_7_0_for_RHEL_7_Platform_director_RPMs_x86_64_7Server]


Version-Release number of selected component (if applicable):

All


How reproducible:

Always


Steps to Reproduce:
1) upload an old manifest that contains the before-change reposet names           
2) enable the repos                                                               
3) sync (maybe?)                                                                  
4) disable repos                                                                                       
5) refresh manifest / upload new manifest with new reposet names                                                                              
6) enable repos again                                                             


Actual results:

Error.


Expected results:

Preferably, Satellite should handle the name change.
Comment 1 Brad Buckingham 2015-10-13 13:38:03 EDT
Hi David, can you attach the manifest to the BZ?

Also, is there a workaround for handling the scenario when the error?
Comment 2 David Davis 2015-10-14 11:38:09 EDT
Once you've disabled the old repos, there is no workaround (other than go into the database and removing the old content). I guess the workaround would be not to disable your old repos and then enable them again if the product name in the manifest changes but not sure customers would be knowledgeable enough to do avoid that.
Comment 8 Bryan Kearney 2016-08-04 16:14:37 EDT
Moving 6.2 bugs out to sat-backlog.
Comment 10 Michael Hrivnak 2017-03-22 10:45:44 EDT
This doesn't look like a Pulp bug. Here's what I think happened:

Katello tried to configure two different Pulp repositories to publish at the same location on the filesystem. Pulp doesn't allow that for obvious reasons, and thus returned an error.

I can imagine that if the name of the repo changed in the manifest, it might be difficult for Katello to figure out that it needed to update/modify an existing repo, or at least delete the old one before re-creating it as the new one.

Justin, what do you make of this?
Comment 11 Justin Sherrill 2017-03-22 10:55:13 EDT
yes, what you said is mostly correct.  Its not really the name of the repo that is important, but the fact that two different content sets were imported from manifests that had the same location on the cdn (and thus we tried to make two repos in pulp with the same location on the local filesystem). 

This is not 'fixed' other than we expect these content sets to not change.
Comment 12 Bryan Kearney 2017-08-01 16:34:25 EDT
Thank you for your interest in Satellite 6. We have evaluated this request, and we do not expect this to be implemented in product in the foreseeable future. We are therefore closing this out as WONTFIX. If you have any concerns about this, please feel free to contact Rich Jerrido or Bryan Kearney. Thank you.

Note You need to log in before you can comment on or make changes to this bug.